/*
	Copyright (C) 2009 -=[dxp]=-

	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef FUNCTIONS_H
#define FUNCTIONS_H 1

#include <inttypes.h>

void reset_input_mode(void);
void signal_handler(int sig);
void Usage(const uint32_t found);
void Error(const int exit, const int errcode, const char *msg);
void md5crack(void);
void sha1crack(void);
void (*calculation)(void);
void Found(const char *word, const char *chash, const char *ihash, const int mode);
void brute2(void);
void rf(const int pos);
void print_stats(void);
void Exit(const int status);
void bye(void);
char * digest2hash(const unsigned char *digest);
unsigned char * hash2digest(const char *hash);
unsigned char hex2int(const char hex);
unsigned int list_addnode(NODE_T **head, NODE_T *node);
unsigned int list_removenode(NODE_T **head, NODE_T *node);
uint32_t digestcmp(const unsigned char *digest);
uint32_t hashtype(const char *str);
uint32_t list_findnode(NODE_T **list, NODE_T *node);
uint32_t list_countnodes(NODE_T *list);

#endif /* ! FUNCTIONS_H */
